[Yandex Cloud documentation](../../../index.md) > [Yandex Managed Service for Valkey™](../../index.md) > API reference > [REST](../index.md) > [Cluster](index.md) > Update

# Managed Service for Redis API, REST: Cluster.Update

Updates the specified Redis cluster.

## HTTP request

```
PATCH https://mdb.api.cloud.yandex.net/managed-redis/v1/clusters/{clusterId}
```

## Path parameters

#|
||Field | Description ||
|| clusterId | **string**

Required field. ID of the Redis cluster to update.
To get the Redis cluster ID, use a [ClusterService.List](list.md#List) request.

The maximum string length in characters is 50. ||
|#

## Body parameters {#yandex.cloud.mdb.redis.v1.UpdateClusterRequest}

```json
{
  "updateMask": "string",
  "description": "string",
  "labels": "object",
  "configSpec": {
    "version": "string",
    // Includes only one of the fields `redisConfig_5_0`, `redisConfig_6_0`, `redisConfig_6_2`, `redisConfig_7_0`
    "redisConfig_5_0": {
      "maxmemoryPolicy": "string",
      "timeout": "string",
      "password": "string",
      "databases": "string",
      "slowlogLogSlowerThan": "string",
      "slowlogMaxLen": "string",
      "notifyKeyspaceEvents": "string",
      "clientOutputBufferLimitPubsub": {
        "hardLimit": "string",
        "softLimit": "string",
        "softSeconds": "string"
      },
      "clientOutputBufferLimitNormal": {
        "hardLimit": "string",
        "softLimit": "string",
        "softSeconds": "string"
      }
    },
    "redisConfig_6_0": {
      "maxmemoryPolicy": "string",
      "timeout": "string",
      "password": "string",
      "databases": "string",
      "slowlogLogSlowerThan": "string",
      "slowlogMaxLen": "string",
      "notifyKeyspaceEvents": "string",
      "clientOutputBufferLimitPubsub": {
        "hardLimit": "string",
        "softLimit": "string",
        "softSeconds": "string"
      },
      "clientOutputBufferLimitNormal": {
        "hardLimit": "string",
        "softLimit": "string",
        "softSeconds": "string"
      }
    },
    "redisConfig_6_2": {
      "maxmemoryPolicy": "string",
      "timeout": "string",
      "password": "string",
      "databases": "string",
      "slowlogLogSlowerThan": "string",
      "slowlogMaxLen": "string",
      "notifyKeyspaceEvents": "string",
      "clientOutputBufferLimitPubsub": {
        "hardLimit": "string",
        "softLimit": "string",
        "softSeconds": "string"
      },
      "clientOutputBufferLimitNormal": {
        "hardLimit": "string",
        "softLimit": "string",
        "softSeconds": "string"
      },
      "maxmemoryPercent": "string"
    },
    "redisConfig_7_0": {
      "maxmemoryPolicy": "string",
      "timeout": "string",
      "password": "string",
      "databases": "string",
      "slowlogLogSlowerThan": "string",
      "slowlogMaxLen": "string",
      "notifyKeyspaceEvents": "string",
      "clientOutputBufferLimitPubsub": {
        "hardLimit": "string",
        "softLimit": "string",
        "softSeconds": "string"
      },
      "clientOutputBufferLimitNormal": {
        "hardLimit": "string",
        "softLimit": "string",
        "softSeconds": "string"
      },
      "maxmemoryPercent": "string"
    },
    // end of the list of possible fields
    "resources": {
      "resourcePresetId": "string",
      "diskSize": "string",
      "diskTypeId": "string"
    },
    "backupWindowStart": {
      "hours": "integer",
      "minutes": "integer",
      "seconds": "integer",
      "nanos": "integer"
    },
    "access": {
      "dataLens": "boolean",
      "webSql": "boolean"
    },
    "redis": {
      "maxmemoryPolicy": "string",
      "timeout": "string",
      "password": "string",
      "databases": "string",
      "slowlogLogSlowerThan": "string",
      "slowlogMaxLen": "string",
      "notifyKeyspaceEvents": "string",
      "clientOutputBufferLimitPubsub": {
        "hardLimit": "string",
        "softLimit": "string",
        "softSeconds": "string"
      },
      "clientOutputBufferLimitNormal": {
        "hardLimit": "string",
        "softLimit": "string",
        "softSeconds": "string"
      },
      "maxmemoryPercent": "string",
      "luaTimeLimit": "string",
      "replBacklogSizePercent": "string",
      "clusterRequireFullCoverage": "boolean",
      "clusterAllowReadsWhenDown": "boolean",
      "clusterAllowPubsubshardWhenDown": "boolean",
      "lfuDecayTime": "string",
      "lfuLogFactor": "string",
      "turnBeforeSwitchover": "boolean",
      "allowDataLoss": "boolean",
      "useLuajit": "boolean",
      "ioThreadsAllowed": "boolean",
      "zsetMaxListpackEntries": "string",
      "aofMaxSizePercent": "string",
      "activedefrag": "boolean",
      "auditLog": "boolean"
    },
    "diskSizeAutoscaling": {
      "plannedUsageThreshold": "string",
      "emergencyUsageThreshold": "string",
      "diskSizeLimit": "string"
    },
    "backupRetainPeriodDays": "string",
    "modules": {
      "valkeySearch": {
        "enabled": "boolean",
        "readerThreads": "string",
        "writerThreads": "string",
        "version": "string"
      },
      "valkeyJson": {
        "enabled": "boolean",
        "version": "string"
      },
      "valkeyBloom": {
        "enabled": "boolean",
        "version": "string"
      }
    }
  },
  "name": "string",
  "maintenanceWindow": {
    // Includes only one of the fields `anytime`, `weeklyMaintenanceWindow`
    "anytime": "object",
    "weeklyMaintenanceWindow": {
      "day": "string",
      "hour": "string"
    }
    // end of the list of possible fields
  },
  "securityGroupIds": [
    "string"
  ],
  "deletionProtection": "boolean",
  "persistenceMode": "string",
  "networkId": "string",
  "announceHostnames": "boolean",
  "authSentinel": "boolean"
}
```

#|
||Field | Description ||
|| updateMask | **string** (field-mask)

A comma-separated names off ALL fields to be updated.
Only the specified fields will be changed. The others will be left untouched.
If the field is specified in `` updateMask `` and no value for that field was sent in the request,
the field's value will be reset to the default. The default value for most fields is null or 0.

If `` updateMask `` is not sent in the request, all fields' values will be updated.
Fields specified in the request will be updated to provided values.
The rest of the fields will be reset to the default. ||
|| description | **string**

New description of the Redis cluster.

The maximum string length in characters is 256. ||
|| labels | **object** (map<**string**, **string**>)

Custom labels for the Redis cluster as `` key:value `` pairs. Maximum 64 per cluster.
For example, "project": "mvp" or "source": "dictionary".
The new set of labels will completely replace the old ones. To add a label, request the current
set with the [ClusterService.Get](get.md#Get) method, then send an [ClusterService.Update](#Update) request with the new label added to the set.

The maximum string length in characters for each value is 63. The maximum string length in characters for each key is 63. Each key must match the regular expression ` [a-z][-_./\@0-9a-z]* `. Each value must match the regular expression ` [-_./\@0-9a-z]* `. No more than 64 per resource. ||
|| configSpec | **[ConfigSpec](#yandex.cloud.mdb.redis.v1.ConfigSpec)**

New configuration and resources for hosts in the cluster. ||
|| name | **string**

New name for the cluster.

The maximum string length in characters is 63. Value must match the regular expression ` [a-zA-Z0-9_-]* `. ||
|| maintenanceWindow | **[MaintenanceWindow](#yandex.cloud.mdb.redis.v1.MaintenanceWindow)**

New maintenance window settings for the cluster. ||
|| securityGroupIds[] | **string**

User security groups ||
|| deletionProtection | **boolean**

Deletion Protection inhibits deletion of the cluster ||
|| persistenceMode | **enum** (PersistenceMode)

Persistence mode

- `ON`: Cluster persistence mode is on.
- `OFF`: Cluster persistence mode is off.
- `ON_REPLICAS`: Cluster persistence is on for replicas only. ||
|| networkId | **string**

ID of the network to move the cluster to.

The maximum string length in characters is 150. ||
|| announceHostnames | **boolean**

Enable FQDN instead of ip ||
|| authSentinel | **boolean**

Allows to use ACL users to auth in sentinel ||
|#

## ConfigSpec {#yandex.cloud.mdb.redis.v1.ConfigSpec}

#|
||Field | Description ||
|| version | **string**

Version of Redis used in the cluster. ||
|| redisConfig_5_0 | **[RedisConfig5_0](#yandex.cloud.mdb.redis.v1.config.RedisConfig5_0)**

Configuration of a Redis 5.0 server.

Includes only one of the fields `redisConfig_5_0`, `redisConfig_6_0`, `redisConfig_6_2`, `redisConfig_7_0`.

Configuration of a Redis cluster. ||
|| redisConfig_6_0 | **[RedisConfig6_0](#yandex.cloud.mdb.redis.v1.config.RedisConfig6_0)**

Configuration of a Redis 6.0 server.

Includes only one of the fields `redisConfig_5_0`, `redisConfig_6_0`, `redisConfig_6_2`, `redisConfig_7_0`.

Configuration of a Redis cluster. ||
|| redisConfig_6_2 | **[RedisConfig6_2](#yandex.cloud.mdb.redis.v1.config.RedisConfig6_2)**

Configuration of a Redis 6.2 server.

Includes only one of the fields `redisConfig_5_0`, `redisConfig_6_0`, `redisConfig_6_2`, `redisConfig_7_0`.

Configuration of a Redis cluster. ||
|| redisConfig_7_0 | **[RedisConfig7_0](#yandex.cloud.mdb.redis.v1.config.RedisConfig7_0)**

Configuration of a Redis 7.0 server.

Includes only one of the fields `redisConfig_5_0`, `redisConfig_6_0`, `redisConfig_6_2`, `redisConfig_7_0`.

Configuration of a Redis cluster. ||
|| resources | **[Resources](#yandex.cloud.mdb.redis.v1.Resources)**

Resources allocated to Redis hosts. ||
|| backupWindowStart | **[TimeOfDay](#google.type.TimeOfDay)**

Time to start the daily backup, in the UTC timezone. ||
|| access | **[Access](#yandex.cloud.mdb.redis.v1.Access)**

Access policy to DB ||
|| redis | **[RedisConfig](#yandex.cloud.mdb.redis.v1.config.RedisConfig)**

Unified configuration of a Redis cluster ||
|| diskSizeAutoscaling | **[DiskSizeAutoscaling](#yandex.cloud.mdb.redis.v1.DiskSizeAutoscaling)**

Disk size autoscaling settings ||
|| backupRetainPeriodDays | **string** (int64)

Retain period of automatically created backup in days

Acceptable values are 7 to 60, inclusive. ||
|| modules | **[ValkeyModules](#yandex.cloud.mdb.redis.v1.ValkeyModules)**

Valkey modules settings ||
|#

## RedisConfig5_0 {#yandex.cloud.mdb.redis.v1.config.RedisConfig5_0}

Fields and structure of `RedisConfig` reflects Redis configuration file
parameters.

#|
||Field | Description ||
|| maxmemoryPolicy | **enum** (MaxmemoryPolicy)

Redis key eviction policy for a dataset that reaches maximum memory,
available to the host. Redis maxmemory setting depends on Managed
Service for Redis [host class](../../concepts/instance-types.md).
All policies are described in detail in [Redis documentation](https://redis.io/topics/lru-cache).

- `VOLATILE_LRU`: Try to remove less recently used (LRU) keys with `expire set`.
- `ALLKEYS_LRU`: Remove less recently used (LRU) keys.
- `VOLATILE_LFU`: Try to remove least frequently used (LFU) keys with `expire set`.
- `ALLKEYS_LFU`: Remove least frequently used (LFU) keys.
- `VOLATILE_RANDOM`: Try to remove keys with `expire set` randomly.
- `ALLKEYS_RANDOM`: Remove keys randomly.
- `VOLATILE_TTL`: Try to remove less recently used (LRU) keys with `expire set`
and shorter TTL first.
- `NOEVICTION`: Return errors when memory limit was reached and commands could require
more memory to be used. ||
|| timeout | **string** (int64)

Time that Redis keeps the connection open while the client is idle.
If no new command is sent during that time, the connection is closed.

Value must be greater than 0. ||
|| password | **string**

Authentication password.

The string length in characters must be 8-128. Value must match the regular expression ` [a-zA-Z0-9@=+?*.,!&#$^<>_-]{8,128} `. ||
|| databases | **string** (int64)

Number of database buckets on a single redis-server process.

Value must be greater than 0. ||
|| slowlogLogSlowerThan | **string** (int64)

Threshold for logging slow requests to server in microseconds (log only slower than it).

The minimum value is 0. ||
|| slowlogMaxLen | **string** (int64)

Max slow requests number to log.

The minimum value is 0. ||
|| notifyKeyspaceEvents | **string**

String setting for pub\sub functionality.

Value must match the regular expression ` [KEg$lshzxeAtm]{0,12} `. ||
|| clientOutputBufferLimitPubsub | **[ClientOutputBufferLimit](#yandex.cloud.mdb.redis.v1.config.RedisConfig5_0.ClientOutputBufferLimit)**

Redis connection output buffers limits for pubsub operations. ||
|| clientOutputBufferLimitNormal | **[ClientOutputBufferLimit](#yandex.cloud.mdb.redis.v1.config.RedisConfig5_0.ClientOutputBufferLimit)**

Redis connection output buffers limits for clients. ||
|#

## ClientOutputBufferLimit {#yandex.cloud.mdb.redis.v1.config.RedisConfig5_0.ClientOutputBufferLimit}

#|
||Field | Description ||
|| hardLimit | **string** (int64)

Total limit in bytes.

The minimum value is 0. ||
|| softLimit | **string** (int64)

Limit in bytes during certain time period.

The minimum value is 0. ||
|| softSeconds | **string** (int64)

Seconds for soft limit.

The minimum value is 0. ||
|#

## RedisConfig6_0 {#yandex.cloud.mdb.redis.v1.config.RedisConfig6_0}

Fields and structure of `RedisConfig` reflects Redis configuration file
parameters.

#|
||Field | Description ||
|| maxmemoryPolicy | **enum** (MaxmemoryPolicy)

Redis key eviction policy for a dataset that reaches maximum memory,
available to the host. Redis maxmemory setting depends on Managed
Service for Redis [host class](../../concepts/instance-types.md).
All policies are described in detail in [Redis documentation](https://redis.io/topics/lru-cache).

- `VOLATILE_LRU`: Try to remove less recently used (LRU) keys with `expire set`.
- `ALLKEYS_LRU`: Remove less recently used (LRU) keys.
- `VOLATILE_LFU`: Try to remove least frequently used (LFU) keys with `expire set`.
- `ALLKEYS_LFU`: Remove least frequently used (LFU) keys.
- `VOLATILE_RANDOM`: Try to remove keys with `expire set` randomly.
- `ALLKEYS_RANDOM`: Remove keys randomly.
- `VOLATILE_TTL`: Try to remove less recently used (LRU) keys with `expire set`
and shorter TTL first.
- `NOEVICTION`: Return errors when memory limit was reached and commands could require
more memory to be used. ||
|| timeout | **string** (int64)

Time that Redis keeps the connection open while the client is idle.
If no new command is sent during that time, the connection is closed.

Value must be greater than 0. ||
|| password | **string**

Authentication password.

The string length in characters must be 8-128. Value must match the regular expression ` [a-zA-Z0-9@=+?*.,!&#$^<>_-]{8,128} `. ||
|| databases | **string** (int64)

Number of database buckets on a single redis-server process.

Value must be greater than 0. ||
|| slowlogLogSlowerThan | **string** (int64)

Threshold for logging slow requests to server in microseconds (log only slower than it).

The minimum value is 0. ||
|| slowlogMaxLen | **string** (int64)

Max slow requests number to log.

The minimum value is 0. ||
|| notifyKeyspaceEvents | **string**

String setting for pub\sub functionality.

Value must match the regular expression ` [KEg$lshzxeAtm]{0,13} `. ||
|| clientOutputBufferLimitPubsub | **[ClientOutputBufferLimit](#yandex.cloud.mdb.redis.v1.config.RedisConfig6_0.ClientOutputBufferLimit)**

Redis connection output buffers limits for pubsub operations. ||
|| clientOutputBufferLimitNormal | **[ClientOutputBufferLimit](#yandex.cloud.mdb.redis.v1.config.RedisConfig6_0.ClientOutputBufferLimit)**

Redis connection output buffers limits for clients. ||
|#

## ClientOutputBufferLimit {#yandex.cloud.mdb.redis.v1.config.RedisConfig6_0.ClientOutputBufferLimit}

#|
||Field | Description ||
|| hardLimit | **string** (int64)

Total limit in bytes.

The minimum value is 0. ||
|| softLimit | **string** (int64)

Limit in bytes during certain time period.

The minimum value is 0. ||
|| softSeconds | **string** (int64)

Seconds for soft limit.

The minimum value is 0. ||
|#

## RedisConfig6_2 {#yandex.cloud.mdb.redis.v1.config.RedisConfig6_2}

Fields and structure of `RedisConfig` reflects Redis configuration file
parameters.

#|
||Field | Description ||
|| maxmemoryPolicy | **enum** (MaxmemoryPolicy)

Redis key eviction policy for a dataset that reaches maximum memory,
available to the host. Redis maxmemory setting depends on Managed
Service for Redis [host class](../../concepts/instance-types.md).
All policies are described in detail in [Redis documentation](https://redis.io/topics/lru-cache).

- `VOLATILE_LRU`: Try to remove less recently used (LRU) keys with `expire set`.
- `ALLKEYS_LRU`: Remove less recently used (LRU) keys.
- `VOLATILE_LFU`: Try to remove least frequently used (LFU) keys with `expire set`.
- `ALLKEYS_LFU`: Remove least frequently used (LFU) keys.
- `VOLATILE_RANDOM`: Try to remove keys with `expire set` randomly.
- `ALLKEYS_RANDOM`: Remove keys randomly.
- `VOLATILE_TTL`: Try to remove less recently used (LRU) keys with `expire set`
and shorter TTL first.
- `NOEVICTION`: Return errors when memory limit was reached and commands could require
more memory to be used. ||
|| timeout | **string** (int64)

Time that Redis keeps the connection open while the client is idle.
If no new command is sent during that time, the connection is closed.

The minimum value is 0. ||
|| password | **string**

Authentication password.

The string length in characters must be 8-128. Value must match the regular expression ` [a-zA-Z0-9@=+?*.,!&#$^<>_-]{8,128} `. ||
|| databases | **string** (int64)

Number of database buckets on a single redis-server process.

Value must be greater than 0. ||
|| slowlogLogSlowerThan | **string** (int64)

Threshold for logging slow requests to server in microseconds (log only slower than it).

The minimum value is 0. ||
|| slowlogMaxLen | **string** (int64)

Max slow requests number to log.

The minimum value is 0. ||
|| notifyKeyspaceEvents | **string**

String setting for pub\sub functionality.

Value must match the regular expression ` [KEg$lshzxeAtm]{0,13} `. ||
|| clientOutputBufferLimitPubsub | **[ClientOutputBufferLimit](#yandex.cloud.mdb.redis.v1.config.RedisConfig6_2.ClientOutputBufferLimit)**

Redis connection output buffers limits for pubsub operations. ||
|| clientOutputBufferLimitNormal | **[ClientOutputBufferLimit](#yandex.cloud.mdb.redis.v1.config.RedisConfig6_2.ClientOutputBufferLimit)**

Redis connection output buffers limits for clients. ||
|| maxmemoryPercent | **string** (int64)

Redis maxmemory percent

Acceptable values are 1 to 75, inclusive. ||
|#

## ClientOutputBufferLimit {#yandex.cloud.mdb.redis.v1.config.RedisConfig6_2.ClientOutputBufferLimit}

#|
||Field | Description ||
|| hardLimit | **string** (int64)

Total limit in bytes.

The minimum value is 0. ||
|| softLimit | **string** (int64)

Limit in bytes during certain time period.

The minimum value is 0. ||
|| softSeconds | **string** (int64)

Seconds for soft limit.

The minimum value is 0. ||
|#

## RedisConfig7_0 {#yandex.cloud.mdb.redis.v1.config.RedisConfig7_0}

Fields and structure of `RedisConfig` reflects Redis configuration file
parameters.

#|
||Field | Description ||
|| maxmemoryPolicy | **enum** (MaxmemoryPolicy)

Redis key eviction policy for a dataset that reaches maximum memory,
available to the host. Redis maxmemory setting depends on Managed
Service for Redis [host class](../../concepts/instance-types.md).
All policies are described in detail in [Redis documentation](https://redis.io/topics/lru-cache).

- `VOLATILE_LRU`: Try to remove less recently used (LRU) keys with `expire set`.
- `ALLKEYS_LRU`: Remove less recently used (LRU) keys.
- `VOLATILE_LFU`: Try to remove least frequently used (LFU) keys with `expire set`.
- `ALLKEYS_LFU`: Remove least frequently used (LFU) keys.
- `VOLATILE_RANDOM`: Try to remove keys with `expire set` randomly.
- `ALLKEYS_RANDOM`: Remove keys randomly.
- `VOLATILE_TTL`: Try to remove less recently used (LRU) keys with `expire set`
and shorter TTL first.
- `NOEVICTION`: Return errors when memory limit was reached and commands could require
more memory to be used. ||
|| timeout | **string** (int64)

Time that Redis keeps the connection open while the client is idle.
If no new command is sent during that time, the connection is closed.

The minimum value is 0. ||
|| password | **string**

Authentication password.

The string length in characters must be 8-128. Value must match the regular expression ` [a-zA-Z0-9@=+?*.,!&#$^<>_-]{8,128} `. ||
|| databases | **string** (int64)

Number of database buckets on a single redis-server process.

Value must be greater than 0. ||
|| slowlogLogSlowerThan | **string** (int64)

Threshold for logging slow requests to server in microseconds (log only slower than it).

The minimum value is 0. ||
|| slowlogMaxLen | **string** (int64)

Max slow requests number to log.

The minimum value is 0. ||
|| notifyKeyspaceEvents | **string**

String setting for pub\sub functionality.

Value must match the regular expression ` [KEg$lshzxeAtm]{0,13} `. ||
|| clientOutputBufferLimitPubsub | **[ClientOutputBufferLimit](#yandex.cloud.mdb.redis.v1.config.RedisConfig7_0.ClientOutputBufferLimit)**

Redis connection output buffers limits for pubsub operations. ||
|| clientOutputBufferLimitNormal | **[ClientOutputBufferLimit](#yandex.cloud.mdb.redis.v1.config.RedisConfig7_0.ClientOutputBufferLimit)**

Redis connection output buffers limits for clients. ||
|| maxmemoryPercent | **string** (int64)

Redis maxmemory percent

Acceptable values are 1 to 75, inclusive. ||
|#

## ClientOutputBufferLimit {#yandex.cloud.mdb.redis.v1.config.RedisConfig7_0.ClientOutputBufferLimit}

#|
||Field | Description ||
|| hardLimit | **string** (int64)

Total limit in bytes.

The minimum value is 0. ||
|| softLimit | **string** (int64)

Limit in bytes during certain time period.

The minimum value is 0. ||
|| softSeconds | **string** (int64)

Seconds for soft limit.

The minimum value is 0. ||
|#

## Resources {#yandex.cloud.mdb.redis.v1.Resources}

#|
||Field | Description ||
|| resourcePresetId | **string**

Required field. ID of the preset for computational resources available to a host (CPU, memory etc.).
All available presets are listed in the [documentation](../../concepts/instance-types.md). ||
|| diskSize | **string** (int64)

Volume of the storage available to a host, in bytes. ||
|| diskTypeId | **string**

Type of the storage environment for the host.
Possible values:
* network-ssd - network SSD drive,
* local-ssd - local SSD storage. ||
|#

## TimeOfDay {#google.type.TimeOfDay}

Represents a time of day. The date and time zone are either not significant
or are specified elsewhere. An API may choose to allow leap seconds. Related
types are [google.type.Date](https://github.com/googleapis/googleapis/blob/master/google/type/date.proto) and [google.protobuf.Timestamp](https://github.com/protocolbuffers/protobuf/blob/master/src/google/protobuf/timestamp.proto).

#|
||Field | Description ||
|| hours | **integer** (int32)

Hours of day in 24 hour format. Should be from 0 to 23. An API may choose
to allow the value "24:00:00" for scenarios like business closing time. ||
|| minutes | **integer** (int32)

Minutes of hour of day. Must be from 0 to 59. ||
|| seconds | **integer** (int32)

Seconds of minutes of the time. Must normally be from 0 to 59. An API may
allow the value 60 if it allows leap-seconds. ||
|| nanos | **integer** (int32)

Fractions of seconds in nanoseconds. Must be from 0 to 999,999,999. ||
|#

## Access {#yandex.cloud.mdb.redis.v1.Access}

#|
||Field | Description ||
|| dataLens | **boolean**

Allow access for DataLens ||
|| webSql | **boolean**

Allow access for Web SQL. ||
|#

## RedisConfig {#yandex.cloud.mdb.redis.v1.config.RedisConfig}

Fields and structure of `RedisConfig` reflects Redis configuration file
parameters.

#|
||Field | Description ||
|| maxmemoryPolicy | **enum** (MaxmemoryPolicy)

Redis key eviction policy for a dataset that reaches maximum memory,
available to the host. Redis maxmemory setting depends on Managed
Service for Redis [host class](../../concepts/instance-types.md).
All policies are described in detail in [Redis documentation](https://redis.io/topics/lru-cache).

- `VOLATILE_LRU`: Try to remove less recently used (LRU) keys with `expire set`.
- `ALLKEYS_LRU`: Remove less recently used (LRU) keys.
- `VOLATILE_LFU`: Try to remove least frequently used (LFU) keys with `expire set`.
- `ALLKEYS_LFU`: Remove least frequently used (LFU) keys.
- `VOLATILE_RANDOM`: Try to remove keys with `expire set` randomly.
- `ALLKEYS_RANDOM`: Remove keys randomly.
- `VOLATILE_TTL`: Try to remove less recently used (LRU) keys with `expire set`
and shorter TTL first.
- `NOEVICTION`: Return errors when memory limit was reached and commands could require
more memory to be used. ||
|| timeout | **string** (int64)

Time that Redis keeps the connection open while the client is idle.
If no new command is sent during that time, the connection is closed.

The minimum value is 0. ||
|| password | **string**

Authentication password. ||
|| databases | **string** (int64)

Number of database buckets on a single redis-server process.

Acceptable values are 1 to 1024, inclusive. ||
|| slowlogLogSlowerThan | **string** (int64)

Threshold for logging slow requests to server in microseconds (log only slower than it).

The minimum value is 10. ||
|| slowlogMaxLen | **string** (int64)

Max slow requests number to log.

The minimum value is 0. ||
|| notifyKeyspaceEvents | **string**

String setting for pub\sub functionality. ||
|| clientOutputBufferLimitPubsub | **[ClientOutputBufferLimit](#yandex.cloud.mdb.redis.v1.config.RedisConfig.ClientOutputBufferLimit)**

Redis connection output buffers limits for pubsub operations. ||
|| clientOutputBufferLimitNormal | **[ClientOutputBufferLimit](#yandex.cloud.mdb.redis.v1.config.RedisConfig.ClientOutputBufferLimit)**

Redis connection output buffers limits for clients. ||
|| maxmemoryPercent | **string** (int64)

Redis maxmemory percent

Acceptable values are 1 to 75, inclusive. ||
|| luaTimeLimit | **string** (int64)

Maximum time in milliseconds for Lua scripts, 0 - disabled mechanism

Acceptable values are 0 to 5000, inclusive. ||
|| replBacklogSizePercent | **string** (int64)

Replication backlog size as a percentage of flavor maxmemory

Acceptable values are 1 to 75, inclusive. ||
|| clusterRequireFullCoverage | **boolean**

Controls whether all hash slots must be covered by nodes ||
|| clusterAllowReadsWhenDown | **boolean**

Allows read operations when cluster is down ||
|| clusterAllowPubsubshardWhenDown | **boolean**

Permits Pub/Sub shard operations when cluster is down ||
|| lfuDecayTime | **string** (int64)

The time, in minutes, that must elapse in order for the key counter to be divided by two (or decremented if it has a value less <= 10)

Acceptable values are 0 to 100000, inclusive. ||
|| lfuLogFactor | **string** (int64)

Determines how the frequency counter represents key hits.

Acceptable values are 0 to 1000, inclusive. ||
|| turnBeforeSwitchover | **boolean**

Allows to turn before switchover in RDSync ||
|| allowDataLoss | **boolean**

Allows some data to be lost in favor of faster switchover/restart ||
|| useLuajit | **boolean**

Use JIT for lua scripts and functions ||
|| ioThreadsAllowed | **boolean**

Allow redis to use io-threads ||
|| zsetMaxListpackEntries | **string** (int64)

Controls max number of entries in zset before conversion from memory-efficient listpack to CPU-efficient hash table and skiplist

Acceptable values are 32 to 2048, inclusive. ||
|| aofMaxSizePercent | **string** (int64)

AOF maximum size as a percentage of disk available

Acceptable values are 1 to 99, inclusive. ||
|| activedefrag | **boolean**

Enable active (online) memory defragmentation ||
|| auditLog | **boolean**

Enable/disable audit logs for Valkey ||
|#

## ClientOutputBufferLimit {#yandex.cloud.mdb.redis.v1.config.RedisConfig.ClientOutputBufferLimit}

#|
||Field | Description ||
|| hardLimit | **string** (int64)

Total limit in bytes.

The minimum value is 0. ||
|| softLimit | **string** (int64)

Limit in bytes during certain time period.

The minimum value is 0. ||
|| softSeconds | **string** (int64)

Seconds for soft limit.

The minimum value is 0. ||
|#

## DiskSizeAutoscaling {#yandex.cloud.mdb.redis.v1.DiskSizeAutoscaling}

#|
||Field | Description ||
|| plannedUsageThreshold | **string** (int64)

Amount of used storage for automatic disk scaling in the maintenance window, 0 means disabled, in percent.

Acceptable values are 0 to 100, inclusive. ||
|| emergencyUsageThreshold | **string** (int64)

Amount of used storage for immediately  automatic disk scaling, 0 means disabled, in percent.

Acceptable values are 0 to 100, inclusive. ||
|| diskSizeLimit | **string** (int64)

Limit on how large the storage for database instances can automatically grow, in bytes. ||
|#

## ValkeyModules {#yandex.cloud.mdb.redis.v1.ValkeyModules}

#|
||Field | Description ||
|| valkeySearch | **[ValkeySearch](#yandex.cloud.mdb.redis.v1.ValkeySearch)**

valkey-search module settings ||
|| valkeyJson | **[ValkeyJson](#yandex.cloud.mdb.redis.v1.ValkeyJson)**

valkey-json module settings ||
|| valkeyBloom | **[ValkeyBloom](#yandex.cloud.mdb.redis.v1.ValkeyBloom)**

valkey-bloom module settings ||
|#

## ValkeySearch {#yandex.cloud.mdb.redis.v1.ValkeySearch}

#|
||Field | Description ||
|| enabled | **boolean**

Enable valkey-search module ||
|| readerThreads | **string** (int64)

Controls the amount of threads executing queries

The minimum value is 0. ||
|| writerThreads | **string** (int64)

Controls the amount of threads processing index mutations

The minimum value is 0. ||
|| version | **string**

Module version ||
|#

## ValkeyJson {#yandex.cloud.mdb.redis.v1.ValkeyJson}

#|
||Field | Description ||
|| enabled | **boolean**

Enable valkey-json module ||
|| version | **string**

Module version ||
|#

## ValkeyBloom {#yandex.cloud.mdb.redis.v1.ValkeyBloom}

#|
||Field | Description ||
|| enabled | **boolean**

Enable valkey-bloom module ||
|| version | **string**

Module version ||
|#

## MaintenanceWindow {#yandex.cloud.mdb.redis.v1.MaintenanceWindow}

A maintenance window settings.

#|
||Field | Description ||
|| anytime | **object**

Maintenance operation can be scheduled anytime.

Includes only one of the fields `anytime`, `weeklyMaintenanceWindow`.

The maintenance policy in effect. ||
|| weeklyMaintenanceWindow | **[WeeklyMaintenanceWindow](#yandex.cloud.mdb.redis.v1.WeeklyMaintenanceWindow)**

Maintenance operation can be scheduled on a weekly basis.

Includes only one of the fields `anytime`, `weeklyMaintenanceWindow`.

The maintenance policy in effect. ||
|#

## WeeklyMaintenanceWindow {#yandex.cloud.mdb.redis.v1.WeeklyMaintenanceWindow}

Weelky maintenance window settings.

#|
||Field | Description ||
|| day | **enum** (WeekDay)

Day of the week (in `DDD` format).

- `MON`: Monday.
- `TUE`: Tuesday.
- `WED`: Wednesday.
- `THU`: Thursday.
- `FRI`: Friday.
- `SAT`: Saturday.
- `SUN`: Sunday. ||
|| hour | **string** (int64)

Hour of the day in UTC (in `HH` format).

Acceptable values are 1 to 24, inclusive. ||
|#

## Response {#yandex.cloud.operation.Operation}

**HTTP Code: 200 - OK**

```json
{
  "id": "string",
  "description": "string",
  "createdAt": "string",
  "createdBy": "string",
  "modifiedAt": "string",
  "done": "boolean",
  "metadata": "object",
  // Includes only one of the fields `error`, `response`
  "error": {
    "code": "integer",
    "message": "string",
    "details": [
      "object"
    ]
  },
  "response": "object"
  // end of the list of possible fields
}
```

An Operation resource. For more information, see [Operation](../../../api-design-guide/concepts/operation.md).

#|
||Field | Description ||
|| id | **string**

ID of the operation. ||
|| description | **string**

Description of the operation. 0-256 characters long. ||
|| createdAt | **string** (date-time)

Creation timestamp.

String in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. The range of possible values is from
`0001-01-01T00:00:00Z` to `9999-12-31T23:59:59.999999999Z`, i.e. from 0 to 9 digits for fractions of a second.

To work with values in this field, use the APIs described in the
[Protocol Buffers reference](https://developers.google.com/protocol-buffers/docs/reference/overview).
In some languages, built-in datetime utilities do not support nanosecond precision (9 digits). ||
|| createdBy | **string**

ID of the user or service account who initiated the operation. ||
|| modifiedAt | **string** (date-time)

The time when the Operation resource was last modified.

String in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. The range of possible values is from
`0001-01-01T00:00:00Z` to `9999-12-31T23:59:59.999999999Z`, i.e. from 0 to 9 digits for fractions of a second.

To work with values in this field, use the APIs described in the
[Protocol Buffers reference](https://developers.google.com/protocol-buffers/docs/reference/overview).
In some languages, built-in datetime utilities do not support nanosecond precision (9 digits). ||
|| done | **boolean**

If the value is `false`, it means the operation is still in progress.
If `true`, the operation is completed, and either `error` or `response` is available. ||
|| metadata | **object**

Service-specific metadata associated with the operation.
It typically contains the ID of the target resource that the operation is performed on.
Any method that returns a long-running operation should document the metadata type, if any. ||
|| error | **[Status](#google.rpc.Status)**

The error result of the operation in case of failure or cancellation.

Includes only one of the fields `error`, `response`.

The operation result.
If `done == false` and there was no failure detected, neither `error` nor `response` is set.
If `done == false` and there was a failure detected, `error` is set.
If `done == true`, exactly one of `error` or `response` is set. ||
|| response | **object**

The normal response of the operation in case of success.
If the original method returns no data on success, such as Delete,
the response is [google.protobuf.Empty](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#google.protobuf.Empty).
If the original method is the standard Create/Update,
the response should be the target resource of the operation.
Any method that returns a long-running operation should document the response type, if any.

Includes only one of the fields `error`, `response`.

The operation result.
If `done == false` and there was no failure detected, neither `error` nor `response` is set.
If `done == false` and there was a failure detected, `error` is set.
If `done == true`, exactly one of `error` or `response` is set. ||
|#

## Status {#google.rpc.Status}

The error result of the operation in case of failure or cancellation.

#|
||Field | Description ||
|| code | **integer** (int32)

Error code. An enum value of [google.rpc.Code](https://github.com/googleapis/googleapis/blob/master/google/rpc/code.proto). ||
|| message | **string**

An error message. ||
|| details[] | **object**

A list of messages that carry the error details. ||
|#